// The sender
// StTcpAgent

#include "../tcp/tcp.h"
#include "../tcp/tcp-sink.h"

#define	TCP_REASON_NACK		0x04   // used only in tcp-St.cc

class StTcpAgent : public virtual NewRenoTcpAgent {
public:
	StTcpAgent();
	int	window();
	double windowd();
	void recv(Packet*, Handler*);
	void traceAll();
	double	qwnd_get() { return(double(qwnd_)); }
	void	qwnd_set(double val) { qwnd_ = val; }
	virtual void timeout(int tno);
protected:
	TracedInt		highnack_;
	TracedInt		nack_;
	TracedInt		dupnack_;
	TracedInt		rtxcount_;
	TracedInt		rtx_allow_;
	TracedInt		rtx_stop_;
	TracedInt		rtx_last_;
	TracedInt		nrtx_;
	TracedInt		rwnd_;
	TracedDouble	qwnd_;
	TracedInt		myrecover_;
	TracedInt		mydupwnd_;
	virtual void	send_helper(int);
};

// The receivers
// StTcpSink agent, derived from TcpSink

class NAcker : public Acker {
public:
	NAcker();
	int nack();
	void reset();
protected:
	int lastnack_;	/* Last nack-ed seqno */
};

class StTcpSink : public virtual DelAckSink { 
public:
	StTcpSink(NAcker*);
	TracedInt rwnd_;
	int Seqno();
protected:
	void ack(Packet*);
	NAcker* acker_;
};

// SplitTcpSink agent, derived from TcpSink

class SplitTcpSink : public virtual DelAckSink { 
public:
	SplitTcpSink(Acker*);
	int command(int argc, const char*const* argv);
	Agent *forwarder_;
protected:
	virtual void recvBytes(int nbytes);
	int useHeaders_;	
};

//SplitStTcpSink agent, split version of StTcpSink

class SplitStTcpSink : public StTcpSink, public SplitTcpSink {
public:
	SplitStTcpSink(NAcker*);
};
