/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
// The Xerox code is used for controlling the data transfer, mainly in send()
// and recv(). Compare with TcpApp.

// Copyright (c) Xerox Corporation 1998. All rights reserved.
//
// License is granted to copy, to use, and to make and to use derivative
// works for research and evaluation purposes, provided that Xerox is
// acknowledged in all documentation pertaining to any such copy or
// derivative work. Xerox grants no other licenses expressed or
// implied. The Xerox trade name should not be used in any advertising
// without its written permission. 
//
// XEROX CORPORATION MAKES NO REPRESENTATIONS CONCERNING EITHER THE
// MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF THIS SOFTWARE
// FOR ANY PARTICULAR PURPOSE.  The software is provided "as is" without
// express or implied warranty of any kind.
//
// These notices must be retained in any copies of any part of this
// software. 
//
// $Header: /cvsroot/ns-allinone-2.31/ns-2.31/tcpproxy/tcpproxy.cc,v 1.3 2009/07/23 19:04:41 txo32 Exp $
//
// Tcp application: transmitting real application data
// 
// Allows only one connection. Model underlying TCP connection as a 
// FIFO byte stream, use this to deliver user data

#include "tcpproxy.h"  




static class TcpProxyClass : public TclClass {
	
public:
	TcpProxyClass() : TclClass("Application/TcpProxy") {}
	TclObject* create(int argc, const char*const* argv) {
		if (argc < 5)
		{     
			return (new TcpProxy());
			printf("tcpProxy create without parameters");
		}
		else if (argc >=6) {
			Agent *sink_ = (Agent *)TclObject::lookup(argv[4]);
			Agent *source_ = (Agent *)TclObject::lookup(argv[5]);
			if (sink_ == NULL || source_ == NULL) 
			{
				return NULL;
			}
			return (new TcpProxy(sink_,source_));
		}
		return NULL;
	}
} class_streamer;

TcpProxy::TcpProxy() : Application()
{
	initialize();
	
}

TcpProxy::TcpProxy(Agent *sink, Agent *source) : Application() {
	initialize();

	sink_ = sink;
	sink_->attachApp(this);
	source_ = source;	
}

TcpProxy::~TcpProxy()
{
	// Before we quit, let our agent know what we no longer exist
	// so that it won't give us a call later...
	sink_->attachApp(NULL);

}

void TcpProxy::initialize() {
	//bind("sink_",sink_);
	//bind("source_",source_);
	curbytes_ = 0;
	bufferSize_ = 1024*10;	
}

void TcpProxy::start() 
{
	
}

void TcpProxy::stop()
{
	
}


void TcpProxy::sendData()
{

	/*Event *e = new Event();
	TcpProxyData *d = new TcpProxyData(STREAMER_DATA,packetSize_,
					   seqNr_++,currentRate_);

	// Schedule next send and schedule ack timeout event for this send
	sendTimer_->resched(sendInterval());
	Scheduler::instance().schedule(this,e,maxRtt_);

	lastSendTime_ = Scheduler::instance().clock();

	// Send packet with data
	send(d->size(),d);*/
}


// Send with callbacks to transfer application data
void TcpProxy::send(int nbytes, AppData *cbk)
{

	Application::send(nbytes);

	// Use this only with agents that can handle AppData packets(e.g. UDP).
	// For use with UDP, the buffering above have to be removed.
	// Data buffering and playback at the receiver also have to be
	// rewritten. It is currently assuming the connection to be a FIFO
	// data pipe.
	// agent_->send(nbytes,cbk); 

}

// All we need to know is that our sink has received one message
void TcpProxy::recv(int size)
{
	//printf("tcpProxy::recv() receive bytes: %d\n", size);
	/*
	curbytes_ += size;
	if (curbytes_ >= bufferSize_)
	{
		source_->send(curbytes_);
		curbytes_ = 0;
	}*/
	
	printf("TcpProxy::recv()  receive bytes: %d\n",size);
	source_->send(size);
	

}


int TcpProxy::command(int argc, const char*const* argv)
{
	Tcl& tcl = Tcl::instance();
	
	if(argc == 3) {
		if(strcmp(argv[1],"attach-sink") == 0) {
			sink_ = (Agent *)TclObject::lookup(argv[2]);
			if(sink_ == NULL) {
				tcl.resultf("TcpProxy %s: attached to null sink.", name_);
				return (TCL_ERROR);//Parsing error in event.

			}
			sink_->attachApp(this);
			return (TCL_OK);
		}
		else if(strcmp(argv[1],"attach-source") == 0) {
			source_ = (Agent *)TclObject::lookup(argv[2]);
			if(source_ == NULL) {
				tcl.resultf("TcpProxy %s: attached to null source.", name_);
				return (TCL_ERROR);
			}
			return (TCL_OK);
		}
	}
	return Application::command(argc, argv);
}

void TcpProxy::process_data(int size, AppData* data) 
{
	 

}


