/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
#ifndef TCPPROXY_H
#define TCPPROXY_H
#include "ns-process.h"
#include "../webcache/tcpapp.h"


// Class local to Streamer
class TcpProxy;



//Tu DTCP
// class TcpProxy is similar to TcpApp in that both uses TCP to transport data.
// Some code is the same, but TcpProxy is a one-way application with different
// end applications while TcpApp is a two-way application and have the same
// application at both ends. Therefore, the class is derived from Application
// instead of TcpApp.

class TcpProxy : public Application {
public:
	TcpProxy();
	TcpProxy(Agent *sink, Agent *source);
	~TcpProxy();

	virtual void recv(int nbytes);
	virtual void send(int nbytes, AppData *data);  

	void sendData(); // 
  
  
	virtual void process_data(int size, AppData* data);
	virtual AppData* get_data(int&, AppData*) {
		// Not supported
		abort();
		return NULL;
	}

  
	// Do nothing when a connection is terminated
	virtual void resume() {}
	
	Agent* source(){return (source_);};
	Agent* sink(){return (sink_);};
	int& bufferSize(){return (bufferSize_);};
	
	nsaddr_t orginDestinationAddr;
	nsaddr_t originDstinationPort;
  
protected:
	virtual int command(int argc, const char*const* argv);

  
	// Perhaps use start for determining starting transmission rate?
	// (E.g. playback buffer size/time to fill playback buffer)
	// Start and stop the streaming application.
	virtual void start(); 
	virtual void stop();
	void initialize();
	
protected:
	int bufferSize_;   //buffer size in bytes
	Agent *sink_;
	//TcpProxySink *dst_;
	Agent *source_;
	int curbytes_;
  
  
};

#endif

